package com.yelochick.smartinput;

import com.janetfilter.core.commons.DebugInfo;
import com.janetfilter.core.plugin.MyTransformer;
import com.yelochick.SafeClassWriter;
import jdk.internal.org.objectweb.asm.ClassReader;
import jdk.internal.org.objectweb.asm.ClassWriter;
import jdk.internal.org.objectweb.asm.tree.*;

import static jdk.internal.org.objectweb.asm.Opcodes.*;

/**
 * @author yelochick
 */
public class OsLanguageManagerProxyTransformer implements MyTransformer {

    @Override
    public String getHookClassName() {
        return "O00oOO00";
    }

    @Override
    public byte[] transform(String className, byte[] classBytes, int order) throws Exception {
        ClassReader reader = new ClassReader(classBytes);
        ClassNode node = new ClassNode(ASM5);
        reader.accept(node, 0);

        for (MethodNode m : node.methods) {
            if ("O000000o".equals(m.name) && "(Ljava/lang/String;)Ljava/lang/Boolean;".equals(m.desc)) {
                m.instructions.clear();
                InsnList list = new InsnList();
                list.add(new FieldInsnNode(GETSTATIC, "java/lang/Boolean", "TRUE", "Ljava/lang/Boolean;"));
                list.add(new InsnNode(ARETURN));
                m.instructions.insert(list);
            }
        }

        SafeClassWriter writer = new SafeClassWriter(null, null, ClassWriter.COMPUTE_FRAMES | ClassWriter.COMPUTE_MAXS);
        node.accept(writer);
        return writer.toByteArray();
    }
}
